diff --git a/src/xdisp.c b/src/xdisp.c
index a88fc69..282a543 100644
--- a/src/xdisp.c
+++ b/src/xdisp.c
@@ -13395,6 +17489,69 @@ hscroll_window_tree (Lisp_Object window)
 	      else
 		pt = clip_to_bounds (BEGV, marker_position (w->pointm), ZV);
 
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+/* (gdb) bt
+#0  terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at emacs.c:359
+#1  0x00000001001ee996 in die (
+    msg=0x10032fc88 "charpos < 0 || (charpos >= BUF_BEG (current_buffer) && charpos <= ZV)", file=0x10032e32d "xdisp.c", line=7951) at alloc.c:7214
+#2  0x000000010004d2ab in init_iterator (it=0x7fff5fbf9e80, w=0x11ae62150,
+    charpos=743, bytepos=743, row=0x0, base_face_id=DEFAULT_FACE_ID)
+    at xdisp.c:7950
+#3  0x000000010004efc9 in init_from_display_pos (it=0x7fff5fbf9e80,
+    w=0x11ae62150, pos=0x11f9c0250) at xdisp.c:8404
+#4  0x000000010004f546 in init_to_row_start (it=0x7fff5fbf9e80, w=0x11ae62150,
+    row=0x11f9c0200) at xdisp.c:8528
+#5  0x000000010006e536 in hscroll_window_tree (window=...) at xdisp.c:18619
+*/
+
+/* (gdb) bt
+#0  terminate_due_to_signal (sig=6, backtrace_limit=2147483647) at emacs.c:359
+#1  0x00000001001ecbc6 in die (
+    msg=0x10032fad8 "CHARPOS (pos) >= BEGV && CHARPOS (pos) <= ZV",
+    file=0x10032c49d "xdisp.c", line=11746) at alloc.c:7214
+#2  0x000000010005885d in reseat_1 (it=0x7fff5fbf9e30, pos=...,
+    set_stop_p=false) at xdisp.c:11746
+#3  0x0000000100058707 in reseat (it=0x7fff5fbf9e30, pos=..., force_p=true)
+    at xdisp.c:11698
+#4  0x000000010004c732 in init_iterator (it=0x7fff5fbf9e30, w=0x11bf72c98,
+    charpos=114549, bytepos=114549, row=0x0, base_face_id=DEFAULT_FACE_ID)
+    at xdisp.c:8143
+#5  0x000000010004ce01 in init_from_display_pos (it=0x7fff5fbf9e30,
+    w=0x11bf72c98, pos=0x121243d50) at xdisp.c:8299
+#6  0x000000010004d37e in init_to_row_start (it=0x7fff5fbf9e30, w=0x11bf72c98,
+    row=0x121243d00) at xdisp.c:8423
+#7  0x000000010006c3f7 in hscroll_window_tree (window=...) at xdisp.c:18546
+*/
+
+  /* `init_iterator':  eassert (charpos < 0
+                                || (charpos >= BUF_BEG (current_buffer)
+                                    && charpos <= ZV)); */
+
+  struct display_pos *pos = &cursor_row->start;
+  ptrdiff_t charpos = CHARPOS (pos->pos);
+
+  bool barf_crash_one = (charpos < 0
+                         || (charpos >= BUF_BEG (current_buffer)
+                             && charpos <= ZV))
+                        ? false
+                        : true;
+  if (barf_crash_one)
+    return hscrolled_p;
+
+  /* `reseat_1':  CHARPOS (pos) >= BEGV && CHARPOS (pos) <= ZV */
+  bool barf_crash_two = (charpos >= BEGV && charpos <= ZV)
+                         ? false
+                         : true;
+  if (barf_crash_two)
+    return hscrolled_p;
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
 	      /* Move iterator to pt starting at cursor_row->start in
 		 a line with infinite width.  */
 	      init_to_row_start (&it, w, cursor_row);
@@ -14287,9 +18444,22 @@ redisplay_internal (void)
 	      *w->desired_matrix->method = 0;
 	      debug_method_add (w, "optimization 1");
 #endif
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
 #ifdef HAVE_WINDOW_SYSTEM
+  if (BUFFERP (w->contents)
+      && !NILP (BVAR (XBUFFER (w->contents), crosshairs)))
+    mc_update_window_fringes (w, false);
+    else
 	      update_window_fringes (w, false);
 #endif
+
+/* *************************************************************************** */
+
+
 	      goto update;
 	    }
 	  else
@@ -17687,10 +21857,22 @@ redisplay_window (Lisp_Object window, bool just_this_one_p)
     }
 
 #ifdef HAVE_WINDOW_SYSTEM
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  bool keep_current_p = (just_this_one_p
+                         || (!used_current_matrix_p && !overlay_arrow_seen)
+                         || w->pseudo_window_p);
+
+  bool fringes_updated_p = (BUFFERP (w->contents)
+                            && !NILP (BVAR (XBUFFER (w->contents), crosshairs)))
+                           ? mc_update_window_fringes (w, keep_current_p)
+                           : update_window_fringes (w, keep_current_p);
+
   if (FRAME_WINDOW_P (f)
-      && update_window_fringes (w, (just_this_one_p
-				    || (!used_current_matrix_p && !overlay_arrow_seen)
-				    || w->pseudo_window_p)))
+      && fringes_updated_p)
     {
       update_begin (f);
       block_input ();
@@ -17705,6 +21887,9 @@ redisplay_window (Lisp_Object window, bool just_this_one_p)
       update_end (f);
     }
 
+/* *************************************************************************** */
+
+
   if (WINDOW_BOTTOM_DIVIDER_WIDTH (w))
     x_draw_bottom_divider (w);
 #endif /* HAVE_WINDOW_SYSTEM */
@@ -18010,6 +22195,19 @@ try_window_reusing_current_matrix (struct window *w)
 	     scroll_run_hook will clear the cursor, and use the
 	     current matrix to get the height of the row the cursor is
 	     in.  */
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  if (trace_redisplay_p)
+    fprintf (stderr, "try_window_reusing_current_matrix [1 of 2] (%s)\n", mc_window (w));
+
+  mc_pre_scroll_clean (w);
+
+/* *************************************************************************** */
+
+
 	  run.current_y = start_row->y;
 	  run.desired_y = it.current_y;
 	  run.height = it.last_visible_y - it.current_y;
@@ -18173,6 +22371,19 @@ try_window_reusing_current_matrix (struct window *w)
 	}
 
       /* Scroll the display.  */
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  if (trace_redisplay_p)
+    fprintf (stderr, "try_window_reusing_current_matrix [2 of 2] (%s)\n", mc_window (w));
+
+  mc_pre_scroll_clean (w);
+
+/* *************************************************************************** */
+
+
       run.current_y = first_reusable_row->y;
       run.desired_y = WINDOW_HEADER_LINE_HEIGHT (w);
       run.height = it.last_visible_y - run.current_y;
@@ -19127,6 +23338,19 @@ try_window_id (struct window *w)
   /* Scroll the display.  Do it before changing the current matrix so
      that xterm.c doesn't get confused about where the cursor glyph is
      found.  */
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  if (trace_redisplay_p)
+    fprintf (stderr, "try_window_id (%s)\n", mc_window (w));
+
+  mc_pre_scroll_clean (w);
+
+/* *************************************************************************** */
+
+
   if (dy && run.height)
     {
       update_begin (f);
@@ -20133,6 +24357,17 @@ append_space_for_newline (struct it *it, bool default_face_p)
 	  memset (&it->position, 0, sizeof it->position);
 	  it->object = Qnil;
 	  it->c = it->char_to_display = ' ';
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      if (IT_BYTEPOS (*it) >= ZV_BYTE)
+        it->zv_p = true;
+
+/* *************************************************************************** */
+
+
 	  it->len = 1;
 
 	  /* If the default face was remapped, be sure to use the
@@ -21269,9 +25504,22 @@ maybe_produce_line_number (struct it *it)
       else
 	tem_it.c = tem_it.char_to_display = *p;
       tem_it.len = 1;
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      if (beyond_zv)
+        tem_it.zv_p = true;
+      tem_it.current_y = it->current_y;
+      tem_it.vpos = it->vpos;
       /* Make sure these glyphs will have a "position" of -1.  */
       SET_TEXT_POS (tem_it.position, -1, -1);
       PRODUCE_GLYPHS (&tem_it);
+      tem_it.hpos += 1;
+
+/* *************************************************************************** */
+
 
       /* Stop producing glyphs, and refrain from producing the line
 	 number, if we don't have enough space on this line.  */
@@ -21284,6 +25532,30 @@ maybe_produce_line_number (struct it *it)
 	}
     }
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  Lisp_Object buf = it->w->contents;
+  CHECK_BUFFER (buf);
+  struct buffer *b = XBUFFER (buf);
+  struct buffer *old_buffer = NULL;
+  /* Needed so that buffer-local values can be determined; e.g., when switching
+  to the minibuffer. */
+  if (b != current_buffer)
+    {
+      old_buffer = current_buffer;
+      set_buffer_internal (b);
+    }
+  it->w->mc.lnum_pixel_width = (!NILP (Vdisplay_line_numbers))
+                               ? tem_it.current_x
+                               : 0;
+  if (old_buffer)
+    set_buffer_internal (old_buffer);
+
+/* *************************************************************************** */
+
+
   /* Record the width in pixels we need for the line number display.  */
   it->lnum_pixel_width = tem_it.current_x;
   /* Copy the produced glyphs into IT's glyph_row.  */
@@ -27092,6 +31364,20 @@ append_glyph (struct it *it)
 	    g[1] = *g;
 	  glyph = it->glyph_row->glyphs[area];
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->x = it->current_x;
+      glyph->y = it->current_y;
+      glyph->hpos = it->hpos;
+      glyph->vpos = it->vpos;
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
       glyph->charpos = CHARPOS (it->position);
       glyph->object = it->object;
       if (it->pixel_width > 0)
@@ -27175,6 +31461,20 @@ append_composite_glyph (struct it *it)
 	    g[1] = *g;
 	  glyph = it->glyph_row->glyphs[it->area];
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->x = it->current_x;
+      glyph->y = it->current_y;
+      glyph->hpos = it->hpos;
+      glyph->vpos = it->vpos;
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
       glyph->charpos = it->cmp_it.charpos;
       glyph->object = it->object;
       eassert (it->pixel_width <= SHRT_MAX);
@@ -27383,6 +31683,20 @@ produce_image_glyph (struct it *it)
 	}
       if (glyph < it->glyph_row->glyphs[area + 1])
 	{
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->x = it->current_x;
+      glyph->y = it->current_y;
+      glyph->hpos = it->hpos;
+      glyph->vpos = it->vpos;
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
 	  glyph->charpos = CHARPOS (it->position);
 	  glyph->object = it->object;
 	  glyph->pixel_width = clip_to_bounds (-1, it->pixel_width, SHRT_MAX);
@@ -27486,6 +31800,20 @@ produce_xwidget_glyph (struct it *it)
 	}
       if (glyph < it->glyph_row->glyphs[area + 1])
 	{
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->x = it->current_x;
+      glyph->y = it->current_y;
+      glyph->hpos = it->hpos;
+      glyph->vpos = it->vpos;
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
 	  glyph->charpos = CHARPOS (it->position);
 	  glyph->object = it->object;
 	  glyph->pixel_width = clip_to_bounds (-1, it->pixel_width, SHRT_MAX);
@@ -27572,6 +31900,20 @@ append_stretch_glyph (struct it *it, Lisp_Object object,
 	    width -= it->first_visible_x - it->current_x;
 	  eassert (width > 0);
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->x = it->current_x;
+      glyph->y = it->current_y;
+      glyph->hpos = it->hpos;
+      glyph->vpos = it->vpos;
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
       glyph->charpos = CHARPOS (it->position);
       glyph->object = object;
       /* FIXME: It would be better to use TYPE_MAX here, but
@@ -28026,6 +32368,20 @@ append_glyphless_glyph (struct it *it, int face_id, bool for_no_font, int len,
 	    g[1] = *g;
 	  glyph = it->glyph_row->glyphs[area];
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      glyph->x = it->current_x;
+      glyph->y = it->current_y;
+      glyph->hpos = it->hpos;
+      glyph->vpos = it->vpos;
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
       glyph->charpos = CHARPOS (it->position);
       glyph->object = it->object;
       eassert (it->pixel_width <= SHRT_MAX);
@@ -29076,10 +33432,33 @@ x_insert_glyphs (struct window *w, struct glyph_row *updated_row,
 
   /* Write the glyphs.  */
   hpos = start - row->glyphs[updated_area];
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  if ((w->mc_elts.used > 0 || w->ch_elts.used > 0 || w->fc_elts.used > 0)
+      && updated_area == TEXT_AREA)
+    {
+      struct glyph_matrix *matrix = w->current_matrix;
+      int vpos = MATRIX_ROW_VPOS (row, matrix);
+      int start_x = w->output_cursor.x;
+      int start_hpos = hpos;
+      int end_hpos = hpos + len;
+      bool clear_eol_p = false;
+      enum draw_glyphs_face hl = DRAW_NORMAL_TEXT;
+      TRACE ((stderr, "x_insert_glyphs (%d):  start_x (%d) | start_hpos (%d) | end_hpos (%d)\n",
+                      vpos, start_x, start_hpos, end_hpos));
+      mc_redraw_row (w, matrix, row, start_x, start_hpos, end_hpos, clear_eol_p, hl);
+    }
+    else
   draw_glyphs (w, w->output_cursor.x, row, updated_area,
 	       hpos, hpos + len,
 	       DRAW_NORMAL_TEXT, 0);
 
+/* *************************************************************************** */
+
+
   /* Advance the output cursor.  */
   w->output_cursor.hpos += len;
   w->output_cursor.x += shift_by_width;
@@ -29505,9 +33884,31 @@ x_fix_overlapping_area (struct window *w, struct glyph_row *row,
 	  while (i < row->used[area]
 		 && row->glyphs[area][i].overlaps_vertically_p);
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+        if ((w->mc_elts.used > 0 || w->ch_elts.used > 0 || w->fc_elts.used > 0)
+            && area == TEXT_AREA)
+          {
+            struct glyph_matrix *matrix = w->current_matrix;
+            int vpos = MATRIX_ROW_VPOS (row, matrix);
+            int start_hpos = start;
+            int end_hpos = i;
+            bool clear_eol_p = false;
+            enum draw_glyphs_face hl = DRAW_NORMAL_TEXT;
+            TRACE ((stderr, "x_fix_overlapping_area (%d):  start_x (%d) | start_hpos (%d) | end_hpos (%d)\n",
+                            vpos, start_x, start_hpos, end_hpos));
+            mc_redraw_row (w, matrix, row, start_x, start_hpos, end_hpos, clear_eol_p, hl);
+          }
+          else
 	  draw_glyphs (w, start_x, row, area,
 		       start, i,
 		       DRAW_NORMAL_TEXT, overlaps);
+
+/* *************************************************************************** */
+
+
 	}
       else
 	{
@@ -29758,10 +34159,17 @@ display_and_set_cursor (struct window *w, bool on,
   new_cursor_type = get_window_cursor_type (w, glyph,
 					    &new_cursor_width, &active_cursor);
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
   /* If cursor is currently being shown and we don't want it to be or
      it is in the wrong place, or the cursor type is not what we want,
      erase it.  */
   if (w->phys_cursor_on_p
+      && NILP (BVAR (XBUFFER (w->contents), crosshairs))
+      && NILP (BVAR (XBUFFER (w->contents), fc_visible))
+      && NILP (BVAR (XBUFFER (w->contents), mc_conf))
       && (!on
 	  || w->phys_cursor.x != x
 	  || w->phys_cursor.y != y
@@ -29774,6 +34182,9 @@ display_and_set_cursor (struct window *w, bool on,
 	      && new_cursor_width != w->phys_cursor_width)))
     erase_phys_cursor (w);
 
+/* *************************************************************************** */
+
+
   /* Don't check phys_cursor_on_p here because that flag is only set
      to false in some cases where we know that the cursor has been
      completely erased, to avoid the extra work of erasing the cursor
@@ -29792,9 +34203,19 @@ display_and_set_cursor (struct window *w, bool on,
       w->phys_cursor.vpos = vpos;
     }
 
-  FRAME_RIF (f)->draw_window_cursor (w, glyph_row, x, y,
-                                     new_cursor_type, new_cursor_width,
-                                     on, active_cursor);
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  if (NILP (BVAR (XBUFFER (w->contents), crosshairs))
+      && NILP (BVAR (XBUFFER (w->contents), fc_visible))
+      && NILP (BVAR (XBUFFER (w->contents), mc_conf)))
+    FRAME_RIF (f)->draw_window_cursor (w, glyph_row, x, y, new_cursor_type,
+                                       new_cursor_width, on, active_cursor);
+
+/* *************************************************************************** */
+
+
 }
 
 
@@ -29887,7 +34308,27 @@ draw_row_with_mouse_face (struct window *w, int start_x, struct glyph_row *row,
 #ifdef HAVE_WINDOW_SYSTEM
   if (FRAME_WINDOW_P (XFRAME (w->frame)))
     {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      if (w->mc_elts.used > 0 || w->ch_elts.used > 0 || w->fc_elts.used > 0)
+        {
+          struct glyph_matrix *matrix = w->current_matrix;
+          int vpos = MATRIX_ROW_VPOS (row, matrix);
+          bool clear_eol_p = false;
+          enum draw_glyphs_face hl = draw;
+          TRACE ((stderr, "draw_row_with_mouse_face (%d):  start_x (%d) | start_hpos (%d) | end_hpos (%d)\n",
+                          vpos, start_x, start_hpos, end_hpos));
+          mc_redraw_row (w, matrix, row, start_x, start_hpos, end_hpos, clear_eol_p, hl);
+        }
+        else
       draw_glyphs (w, start_x, row, TEXT_AREA, start_hpos, end_hpos, draw, 0);
+
+/* *************************************************************************** */
+
+
       return;
     }
 #endif
@@ -31945,11 +36386,34 @@ expose_area (struct window *w, struct glyph_row *row, XRectangle *r,
   struct glyph *last;
   int first_x, start_x, x;
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
   if (area == TEXT_AREA && row->fill_line_p)
+    {
+      if (w->mc_elts.used > 0 || w->ch_elts.used > 0 || w->fc_elts.used > 0)
+        {
+          struct glyph_matrix *matrix = w->current_matrix;
+          int vpos = MATRIX_ROW_VPOS (row, matrix);
+          int start_x = 0;
+          int start_hpos = 0;
+          int end_hpos = row->used[TEXT_AREA];
+          bool clear_eol_p = false;
+          enum draw_glyphs_face hl = DRAW_NORMAL_TEXT;
+          TRACE ((stderr, "expose_area (%d):  Write the whole line.\n", vpos));
+          mc_redraw_row (w, matrix, row, start_x, start_hpos, end_hpos, clear_eol_p, hl);
+        }
+        else
     /* If row extends face to end of line write the whole line.  */
     draw_glyphs (w, 0, row, area,
 		 0, row->used[area],
 		 DRAW_NORMAL_TEXT, 0);
+    }
+
+/* *************************************************************************** */
+
+
   else
     {
       /* Set START_X to the window-relative start position for drawing glyphs of
@@ -31981,11 +36445,34 @@ expose_area (struct window *w, struct glyph_row *row, XRectangle *r,
 	  ++last;
 	}
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
       /* Repaint.  */
-      if (last > first)
+      /* Floating fake cursors will exist when (last == first). */
+      if ((w->mc_elts.used > 0 || w->ch_elts.used > 0 || w->fc_elts.used > 0)
+          && area == TEXT_AREA)
+        {
+          struct glyph_matrix *matrix = w->current_matrix;
+          int vpos = MATRIX_ROW_VPOS (row, matrix);
+          start_x = first_x - start_x;
+          int start_hpos = first - row->glyphs[TEXT_AREA];
+          int end_hpos = last - row->glyphs[TEXT_AREA];
+          bool clear_eol_p = false;
+          enum draw_glyphs_face hl = DRAW_NORMAL_TEXT;
+          TRACE ((stderr, "expose_area (%d):  start_x (%d) | start_hpos (%d) | end_hpos (%d)\n",
+                          vpos, start_x, start_hpos, end_hpos));
+          mc_redraw_row (w, matrix, row, start_x, start_hpos, end_hpos, clear_eol_p, hl);
+        }
+        else if (last > first)
 	draw_glyphs (w, first_x - start_x, row, area,
 		     first - row->glyphs[area], last - row->glyphs[area],
 		     DRAW_NORMAL_TEXT, 0);
+
+/* *************************************************************************** */
+
+
     }
 }
 
@@ -31999,10 +36486,33 @@ expose_line (struct window *w, struct glyph_row *row, XRectangle *r)
 {
   eassert (row->enabled_p);
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
   if (row->mode_line_p || w->pseudo_window_p)
+    {
+      if (w->mc_elts.used > 0 || w->ch_elts.used > 0 || w->fc_elts.used > 0)
+        {
+          struct glyph_matrix *matrix = w->current_matrix;
+          int vpos = MATRIX_ROW_VPOS (row, matrix);
+          int start_x = 0;
+          int start_hpos = 0;
+          int end_hpos = row->used[TEXT_AREA];
+          bool clear_eol_p = false;
+          enum draw_glyphs_face hl = DRAW_NORMAL_TEXT;
+          TRACE ((stderr, "expose_line (%d):  Write the whole line.\n", vpos));
+          mc_redraw_row (w, matrix, row, start_x, start_hpos, end_hpos, clear_eol_p, hl);
+        }
+        else
     draw_glyphs (w, 0, row, TEXT_AREA,
 		 0, row->used[TEXT_AREA],
 		 DRAW_NORMAL_TEXT, 0);
+    }
+
+/* *************************************************************************** */
+
+
   else
     {
       if (row->used[LEFT_MARGIN_AREA])
@@ -32550,6 +37060,22 @@ x_intersect_rectangles (XRectangle *r1, XRectangle *r2, XRectangle *result)
 void
 syms_of_xdisp (void)
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  defsubr (&Smc_dump_glyph_row);
+
+  defsubr (&Smc_dump_glyph_matrix);
+
+  defsubr (&Smc_current_column);
+
+  defsubr (&Smc_stderr);
+
+/* *************************************************************************** */
+
+
   Vwith_echo_area_save_vector = Qnil;
   staticpro (&Vwith_echo_area_save_vector);
 
